#!/usr/bin/env ruby -Ks

require "uri"
require "open-uri"
require "nkf"


VID_EXPR	= /([a-zA-Z])(\d+)/
QUERY_EXPR	= /.+<a href="index.rb\?(.+?party.+?)">/
LIST_EXPR	= /master|ninjin@ninjinix/
ENTRY_SEP_EXPR	= /\s*<br\s*\/?>\s*/
ENTRY_TEMPLATE	= /^(.+?) i(.+?)jA(.+?)B(.+?)B/

BASE = {
  "A"	=> "http://ninjinel.sakura.ne.jp/wolfa/index.rb",
  "B"	=> "http://ninjinel.sakura.ne.jp/wolfb/index.rb",
  "C"	=> "http://ninjinel.x0.com/wolfc/index.rb",
  "D"	=> "http://ninjin001.x0.com/wolfd/index.rb",
  "E"	=> "http://ninjin001.x0.com/wolfe/index.rb",
  "F"	=> "http://ninjin002.x0.com/wolff/index.rb",
  "Z"	=> "http://ninjinix.x0.com/wolfz/index.rb",
}


arg = ARGV.shift.to_s
m = VID_EXPR.match(arg)
raise "wrong village specification.\n" unless m

_, site, vid = m.to_a
site.capitalize!
uri = BASE[site]
raise "`#{site}' is not supported.\n" unless uri

uri = URI.parse(uri)
uri.query = "vid=#{vid}"

doc = uri.open.read
doc =~ QUERY_EXPR
if $1
  uri.query = $1
else
  uri.query = "vid=#{vid}&mes=all"
end

doc = uri.open.read
doc = NKF.nkf("-s", doc)
list = doc.select {|line| line =~ LIST_EXPR}

puts "|z|Q||E|Rg|"
list.shift.split(ENTRY_SEP_EXPR).each do
  |entry|
  _, char, login, doa, role = entry.match(ENTRY_TEMPLATE).to_a
  login.gsub!(/<.+?>/, "")
  login = "[[#{login}]]"
  puts "|#{[char, login, doa, role].join("|")}||"
end
